#include <amdis/Initfile.hpp>

#include <amdis/InitfileParser.hpp>

// a parser for arithmetic expressions
// #include <muParser.h>

namespace AMDiS
{
//   namespace detail
//   {
//     double mu_parser_eval(std::string const& valStr)
//     {
//       mu::Parser parser;
//       parser.DefineConst(_T("M_PI"), m_pi);
//       parser.DefineConst(_T("M_E"), m_e);
//
//       parser.SetExpr(valStr);
//       return parser.Eval();
//     }
//   }

void Initfile::init(std::string in)
{
  singlett().read(in);
  singlett().getInternalParameters();
}


void Initfile::read(std::string fn, bool /*force*/)
{
  InitfileParser::readInitfile(fn, pt_);
}


void Initfile::getInternalParameters()
{
  int val = 0;
  get("level of information", val);
  msgInfo = val;

  val = 1;
  get("parameter information", val);
  paramInfo = val;

  val = 0;
  get("break on missing tag", val);
  breakOnMissingTag = val;

  if (msgInfo == 0)
    paramInfo = 0;
}


void Initfile::printParameters()
{
  // TODO: implement printing of all parameters
}

} // end namespace AMDiS
